//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;
using System.Threading;

namespace ThreadSynchonization
{
	class AutoResetEventTest
	{
		static AutoResetEvent resetEvent = new AutoResetEvent(false);
		static void DoWork()
		{
			resetEvent.WaitOne();
			Console.WriteLine("Wątek {0} rozpoczął pracę", Thread.CurrentThread.Name);
			resetEvent.Set();
		}
		static void Main(string[] args)
		{
			Thread a = new Thread(new ThreadStart(DoWork));
			a.Name = "a";
			Thread b = new Thread(new ThreadStart(DoWork));
			b.Name = "b";
			Thread c = new Thread(new ThreadStart(DoWork));
			c.Name = "c";
			a.Start();
			b.Start();
			c.Start();
			resetEvent.Set();
			a.Join();
			b.Join();
			c.Join();
		}
	}
}
